/* 
 * reboot_clnt.c
 *
 * x-kernel v3.1	12/10/90
 *
 * Copyright (C) 1990  Larry L. Peterson and Norman C. Hutchinson
 */

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <sys/file.h>
#include <netinet/in.h>
#include <signal.h>
#include <netdb.h>
#include <errno.h>
#include <stdio.h>
#include <sys/time.h>

main(argc,argv)
int	argc;
char	*argv[];
{
  struct  sockaddr_in	to,from;
  struct  hostent *answer;
  char	*host;
  char	cmd[100];
  char  buf[100];
  int	size,length;
  int	s;

  if (argc == 1) {
    printf("Usage: reboot <hostname> [<bootfile>]\n");
    return(0);
  }
  host = argv[1];
  if (argc > 2){
    strcpy(cmd,"ie(0,0,0) ");
    strcat(cmd,argv[2]);
  }
  else
    strcpy(cmd,"ie(0,0,0) xkernel");
  if (argc > 3) {
    printf("Usage: <bootfile> must be one argument; e.g., reboot fra \"xtcp -d 1000\"\n");
    return(0);
  }
  to.sin_family = AF_INET;
  to.sin_addr.s_addr = INADDR_ANY;
  to.sin_port = htons(1701);
  if ((s = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
    printf("cannot open socket\n");
    exit(1);
  }	
  if (bind(s, &to, sizeof(to))) {
    printf("cannot bind socket\n");
    exit(1);
  }
  answer = gethostbyname(host);
  bcopy(answer->h_addr,&to.sin_addr.s_addr,answer->h_length);
  to.sin_port = htons(1);
  printf("Rebooting %s <%s> with command -->%s<--\n",answer->h_name,
	 inet_ntoa(to.sin_addr.s_addr),cmd);
  sendto(s, cmd, strlen(cmd)+1, 0, &to, sizeof(to));
  recvfrom(s, buf, length, 0, &from, &size);
  printf("done\n");
  exit(0);
}



